# Enum ARTrackingFailureReason

java.lang.Object
java.lang.Enum<ARTrackingFailureReason>
com.codename1.ar.ARTrackingFailureReason

All Implemented Interfaces:
  `Comparable<ARTrackingFailureReason>`

public enum ARTrackingFailureReason extends Enum<ARTrackingFailureReason>
Why an `ARSession` reports `ARTrackingState#LIMITED` or `ARTrackingState#NOT_TRACKING`. Useful for prompting the user, for example to move the device more slowly or to point it at a textured surface.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `EXCESSIVE_MOTION`
  The device is moving too fast for reliable tracking.
  `INITIALIZING`
  The session is still gathering its first observations; tracking quality improves as the user moves the device.
  `INSUFFICIENT_FEATURES`
  The camera sees too few visual features, for example a blank wall.
  `INSUFFICIENT_LIGHT`
  The scene is too dark for the camera to track features.
  `NONE`
  Tracking is not degraded.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ARTrackingFailureReason`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static ARTrackingFailureReason[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, equals, getDeclaringClass, getEnumValues, hashCode, name, ordinal, setEnumValues, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### NONE

    public static final ARTrackingFailureReason NONE
    Tracking is not degraded.

  - ### INITIALIZING

    public static final ARTrackingFailureReason INITIALIZING
    The session is still gathering its first observations; tracking quality improves as the user moves the device.

  - ### EXCESSIVE_MOTION

    public static final ARTrackingFailureReason EXCESSIVE_MOTION
    The device is moving too fast for reliable tracking.

  - ### INSUFFICIENT_LIGHT

    public static final ARTrackingFailureReason INSUFFICIENT_LIGHT
    The scene is too dark for the camera to track features.

  - ### INSUFFICIENT_FEATURES

    public static final ARTrackingFailureReason INSUFFICIENT_FEATURES
    The camera sees too few visual features, for example a blank wall.

- ## Method Details

  - ### values

    public static ARTrackingFailureReason[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static ARTrackingFailureReason valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null